<?php

set_time_limit(0);

require_once("binary.php");
require_once("load_macbin.php");
require_once("68kdis_traps.php");

function decrm2($f,&$p,$type,$subtype,$im){
	global $err,$ms;
	switch($type){
		case 0: return "D".$subtype;
		case 1: return "A".$subtype;
		case 2: return "(A".$subtype.")";
		case 3: return "(A".$subtype.")+";
		case 4: return "-(A".$subtype.")";
		case 5: $v=getint2mac($f,$p); return sprintf("(D_%04X,A%d)",$v,$subtype);
		case 6:
			$d1=getint1($f,$p); $d2=getint1($f,$p);
			if($d1&1){
				//$err=true; return "TYPE=6 SPEC=1";
				$base=array();
				$r=$d1>>4&15; $s=$d1>>3&1; $m=$d1>>1&3;
				$ss=$d2>>4&3; $ii=$d2>>6&3; $aa=$d2&3; $pp=$d2>>2&1;
				switch($ss){
					case 0: $base[]="????"; $err=true; break;
					case 1: break;
					case 2: $base[]=sprintf("D_%04X",getint2mac($f,$p)); break;
					case 3: $base[]=sprintf("D_%08X",getint4mac($f,$p)); break;
				}
				if(!($ii&2)) $base[]="A".$subtype;
				if($pp==1 and $aa) $base=array("[".implode(",",$base)."]");
				if(!($ii&1)){
					$rg=($r>>3?"A":"D").($r&7); $rg.=".";
					$rg.=$s?"L":"W"; if($m) $rg.="*".(1<<$m);
					$base[]=$rg;
				}
				if($pp==0 and $aa) $base=array("[".implode(",",$base)."]");
				switch($aa){
					case 2: $base[]=sprintf("D_%04X",getint2mac($f,$p)); break;
					case 3: $base[]=sprintf("D_%08X",getint4mac($f,$p)); break;
				}
				return "(".implode(",",$base).")";
			}else{
				//$err=true; return "TYPE=6 SPEC=0";
				$r=$d1>>4&15; $s=$d1>>3&1; $m=$d1>>1&3;
				$rg=($r>>3?"A":"D").($r&7); $rg.=".";
				$rg.=$s?"L":"W"; if($m) $rg.="*".(1<<$m);
				return sprintf("(D_%02X,A%d,%s)",$d2,$subtype,$rg);
			}
		case 7:
			switch($subtype){
				case 0: $v=getint2mac($f,$p); return sprintf("A_%04X.W",$v);
				case 1: $v=getint4mac($f,$p); return sprintf("A_%08X",$v);
				case 2: $v=getint2mac($f,$p); return sprintf("(D_%04X,PC)",$v);
				case 3:
					$d1=getint1($f,$p); $d2=getint1($f,$p);
					if($d1&1){
						$err=true; return "TYPE=7 SUBTYPE=3 SPEC=1";
					}else{
						//$err=true; return "TYPE=6 SUBTYPE=3 SPEC=0";
						$r=$d1>>4&15; $s=$d1>>3&1; $m=$d1>>1&3;
						$rg=($r>>3?"A":"D").($r&7); $rg.=".";
						$rg.=$s?"L":"W"; if($m) $rg.="*".(1<<$m);
						return sprintf("(D_%02X,PC,%s)",$d2,$rg);
					}
				case 4:
					switch($im){
						case "CCR": case "SR": return $im;
						case "imm2": $v=getint2mac($f,$p); return sprintf("#0x%04X",$v);
						case "imm4": $v=getint4mac($f,$p); return sprintf("#0x%08X",$v);
					}
				default: global $err; $err=true; return "TYPE=7 SUBTYPE=".$subtype;
			}
		default: $err=true; return "TYPE=".$type;
	}
}

function decrm($f,&$p,$op,$im){
	return decrm2($f,$p,$op>>3&7,$op&7,$im);
}

$sis=array(".B",".W","",".?");
function decsi($op){
	$si=$op>>6&3;
	global $sis; return $sis[$si];
}
$sis2=array("[ERROR]",".B","",".W");

function decimm($op){
	$imm=$op>>9&7;
	return $imm?$imm:8;
}

$cons=array("T","F","HI","LS","CC","CS","NE","EQ","VC","VS","PL","MI","GE","LT","GT","LE");

function regs($rs,$rv){
	$s="";
	for($i=0;$i<15;$i++){
		if($rs&($rv?0x8000>>$i:1<<$i)){
			$s.=($i>>3?"A":"D").($i&7);
		}
	}
	if($s=="") $s="NONE"; else $s="REGS ".$s;
	return $s;
}

$shs=array("AS","LS","ROX","RO");
$drs=array("R","L");
$bits=array("BTST","BCHG","BCLR","BSET");
$srs=array("CCR","SR","","");

// Filenames:
$fn=$argv[1] or die("Missing executable filename");
$fnannot=$argv[2] or die("Missing annotation filename");

// Load executable:
$f=load_macbin($fn);

$threads=array();
$labels=array();
$comments = array();
$dec=array();

// Load jump table:
$co=$f["CODE"][0];

// Processes/Segment_Manager.pdf
$p=0;
$size_above_A5 = getint4mac($co,$p);
$size_of_globals = getint4mac($co,$p);
$length_of_jump_table = getint4mac($co,$p);
$A5_offset_of_jump_table = getint4mac($co,$p);
$i=0;
while($p<strlen($co)){
	$of=getint2mac($co,$p);
	$s1=getint2mac($co,$p);
	$sg=getint2mac($co,$p);
	$s2=getint2mac($co,$p);
	// 3F 3C = MOVE.W #0xNNNN,-(A7)
	// A9 F0 = _LoadSeg
	if($s1!=0x3F3C or $s2!=0xA9F0) die("Bad entry!");
	$threads[]=array($sg,$of);
	$comments[$sg][$of][] = sprintf("Entry 0x%02X",$i);
	$entries[]=array($sg,$of);
	//$labels[0xA5][$p-8+2][] = ...;
	$i++;
}//print_r($labels);

// Load annotations:
$fannot=file_get_contents($fnannot);
$fannot=explode("\r\n",$fannot);
foreach($fannot as $l){
	//print "ANNOT: ".$l."\r\n";
	@list($ad,$op,$arg,$arg2,$arg3)=explode("\t",$l);
	sscanf($ad,"%02X:%04X",$sg,$of);
	//$ad=addr_to_linear($sg,$of);
	switch ($op) {
		case "LABEL":
			$labels[$sg][$of][]=$arg;
		break;
		case "CODE":
			$threads[]=array($sg,$of);
		break;
		case "JUMPTABLE":
			//print"YEEEEEE".hexdec("0x10");
			$co=substr($f["CODE"][$sg],4);
			$p=$of;
			// (int)"0x10" === 0 !!!
			$n = hexdec($arg); // number of cases
			$first_case = hexdec($arg2) & -1; // &-1 to make it signed
			$target_delta = (int)$arg3; // offset the target of the jump
			$line = "WORD ";
			$addrs = array();
			for ($i=0;$i<$n;$i++) {
				$rel_off = getint2mac($co,$p);
				$target = ($of + $rel_off + $target_delta)&0xFFFF;
				$threads[]=array($sg,$target);
				$labels[$sg][$target][]="case ".($i+$first_case)." // from ".$ad;
				$addrs[] = sprintf('0x%04X', $rel_off);
			}
			$line .= implode(", ", $addrs);
			$line .= " ; jump table";
			$dec[$sg][$of] = $line;
			$next[$sg][$of] = $p;
		break;
		case "STRING":
			$string_type = $arg;
			$co=substr($f["CODE"][$sg],4);
			$p=$of;
			$string = null;
			switch ($string_type) {
				case "C": // C string = zero-terminated
					$string = getzstr($co,$p);
				break;
				case "P": // Pascal string = with length byte
					$len = getint1($co,$p);
					$string = getstr($co,$p,$len);
				break;
			}
			$p += $p&1;
			$labels[$sg][$of][]='"'.$string.'"';
			$line = $string_type."STRING ".'"'.$string.'"';
			$dec[$sg][$of] = $line;
			$next[$sg][$of] = $p;
		break;
	}
}

function checkrefs($v, $add=false, $entry=false) {
	//var_dump($v);
	global $sa, $line, $sg, $threads;
	global $A5_offset_of_jump_table, $length_of_jump_table, $labels, $entries, $comments;
	if(strlen($v)==11 and substr($v,0,3)=="(D_" and substr($v,7,4)==",PC)"){
		$of=hexdec(substr($v,3,4)); if($of>>15) $of-=1<<16;
		$of+=$sa+2;
		//$line.=" ; = 0x".h2($of,4);
		$line.=sprintf(" ; = %02X:%04X",$sg,$of);
		$ref_sg = $sg;
	}elseif(strlen($v)==11 and substr($v,0,3)=="(D_" and substr($v,7,4)==",A5)"){
		$ref_sg = 0xA5;
		$of=hexdec(substr($v,3,4));
		if ($of >= $A5_offset_of_jump_table and $of-$A5_offset_of_jump_table < $length_of_jump_table) {
			$index=($of-$A5_offset_of_jump_table)>>3;
			$line.=" ; = Entry 0x".h2($index,2);
			list($ref_sg,$of) = $entries[$index];
			$line.=sprintf(" = %02X:%04X",$ref_sg,$of);
		}
	}elseif(strlen($v)>=6 and substr($v,0,2)==="A_") {
		// Mac OS system global variables
		$ref_sg = 0xAD;
		$of=hexdec(substr($v,3,4));
	}

	if (isset($of)) {
		if ($add) {
			$threads[]=array($ref_sg,$of);
		}
		if ($entry) {
			$ref = &$comments[$ref_sg][$of];
			$new = "Subroutine entry";
			if (is_null($ref) or array_search($new, $ref) === false) {
				$ref[] = $new;
			}
		}
		if (isset($labels[$ref_sg][$of])) {
			$line.=" ; " . implode(", ", $labels[$ref_sg][$of]);
		}
	}

}

$allend=false;
//print_r($threads);
list($sg,$p)=array_shift($threads);
$co=substr($f["CODE"][$sg],4);
while(!$allend){
	if(isset($dec[$sg][$p])){
		if(count($threads)==0) break;
		list($sg,$p)=array_shift($threads);
		$co=substr($f["CODE"][$sg],4);
		continue;
	}
	$line="???"; $err=false; $sa=$p;
	$op=getint2mac($co,$p);
	$v = null;
	$va = null;
	$vb = null;
	if(0){
	}elseif(($op&0xFF00)==0x0000){
		$siz=decsi($op);
		if($siz=="") $im=sprintf("#0x%08X",getint4mac($co,$p));
			else $im=sprintf("#0x%04X",getint2mac($co,$p));
		$si=$op>>6&3;
		$v=decrm($co,$p,$op,$srs[$si]);
		$line=sprintf("OR%s %s,%s",$siz,$im,$v);
	}elseif(($op&0xFF00)==0x0200){
		$siz=decsi($op);
		if($siz=="") $im=sprintf("#0x%08X",getint4mac($co,$p));
			else $im=sprintf("#0x%04X",getint2mac($co,$p));
		$si=$op>>6&3;
		$v=decrm($co,$p,$op,$srs[$si]);
		$line=sprintf("AND%s %s,%s",$siz,$im,$v);
	}elseif(($op&0xFF00)==0x0400){
		$siz=decsi($op);
		if($siz=="") $im=sprintf("#0x%08X",getint4mac($co,$p));
			else $im=sprintf("#0x%04X",getint2mac($co,$p));
		$v=decrm($co,$p,$op,"");
		$line=sprintf("SUB%s %s,%s",$siz,$im,$v);
	}elseif(($op&0xFFF0)==0x06C0){
		$err=true;
		$line="Unknown (RTM): ".h2($op,4);
	}elseif(($op&0xFF00)==0x0600){
		$siz=decsi($op);
		if($siz=="") $im=sprintf("#0x%08X",getint4mac($co,$p));
			else $im=sprintf("#0x%04X",getint2mac($co,$p));
		$v=decrm($co,$p,$op,"");
		$line=sprintf("ADD%s %s,%s",$siz,$im,$v);
	}elseif(($op&0xFF00)==0x0800){
		$bit=$op>>6&3; $im=sprintf("#0x%04X",getint2mac($co,$p));
		$v=decrm($co,$p,$op,"");
		$line=sprintf("%s %s,%s",$bits[$bit],$im,$v);
	}elseif(($op&0xFF00)==0x0A00){
		$siz=decsi($op);
		if($siz=="") $im=sprintf("#0x%08X",getint4mac($co,$p));
			else $im=sprintf("#0x%04X",getint2mac($co,$p));
		$si=$op>>6&3;
		$v=decrm($co,$p,$op,$srs[$si]);
		$line=sprintf("EOR%s %s,%s",$siz,$im,$v);
	}elseif(($op&0xFF00)==0x0C00){
		$siz=decsi($op);
		if($siz=="") $im=sprintf("#0x%08X",getint4mac($co,$p));
			else $im=sprintf("#0x%04X",getint2mac($co,$p));
		$v=decrm($co,$p,$op,"");
		$line=sprintf("CMP%s %s,%s",$siz,$im,$v);
	}elseif(($op&0xF138)==0x0108){
		$err=true;
		$line="Unknown (MOVEP): ".h2($op,4);
	}elseif(($op&0xF100)==0x0100){
		$bit=$op>>6&3; $r=$op>>9&3;
		$v=decrm($co,$p,$op,"");
		$line=sprintf("%s D%d,%s",$bits[$bit],$r,$v);
	}elseif(($op&0xF000)==0x0000){
		$err=true;
		$line="Unknown (A): ".h2($op,4);
	}elseif(($op&0xC000)==0x0000){
		$si=$op>>12&3; $siz=$sis2[$si];
		$va=decrm($co,$p,$op,$si==2?"imm4":"imm2"); $vb=decrm2($co,$p,$op>>6&7,$op>>9&7,"");
		$line=sprintf("MOVE%s %s,%s",$siz,$va,$vb);
	}elseif(($op&0xF1C0)==0x41C0){
		$v=decrm($co,$p,$op,"imm4");
		$line=sprintf("LEA %s,A%d",$v,$op>>9&7);
	}elseif(($op&0xFF00)==0x4200){
		$v=decrm($co,$p,$op,"");
		$si=decsi($op);
		$line=sprintf("CLR%s %s",$si,$v);
	}elseif(($op&0xFFC0)==0x40C0){
		$v=decrm($co,$p,$op,"");
		$line=sprintf("MOVE SR,%s",$v);
	}elseif(($op&0xFFC0)==0x44C0){
		$err=true;
		$line="Unknown (MOVE rm,CCR): ".h2($op,4);
	}elseif(($op&0xFFC0)==0x46C0){
		$err=true;
		$line="Unknown (MOVE rm,SR): ".h2($op,4);
	}elseif(($op&0xFF00)==0x4400){
		$v=decrm($co,$p,$op,"");
		$si=decsi($op);
		$line=sprintf("NEG%s %s",$si,$v);
	}elseif(($op&0xFF00)==0x4600){
		$v=decrm($co,$p,$op,"");
		$si=decsi($op);
		$line=sprintf("NOT%s %s",$si,$v);
	}elseif(($op&0xFFF8)==0x4840){
		$line=sprintf("SWAP D%d",$op&7);
	}elseif(($op&0xFFF8)==0x4848){
		$err=true;
		$line="Unknown (BKPT): ".h2($op,4);
	}elseif(($op&0xFFC0)==0x4840){
		$v=decrm($co,$p,$op,"imm4");
		$line=sprintf("PEA %s",$v);
	}elseif(($op&0xFFF8)==0x4880){
		$r=$op&7;
		$line=sprintf("EXT.W D%d",$r);
	}elseif(($op&0xFFF8)==0x48C0){
		$r=$op&7;
		$line=sprintf("EXT.L D%d",$r);
	}elseif(($op&0xFFC0)==0x48C0){
		$rs=getint2mac($co,$p); $v=decrm($co,$p,$op,"");
		$line=sprintf("MOVEM %s,%s",regs($rs,true),$v);
	}elseif(($op&0xFFC0)==0x4AC0){
		$err=true;
		$line="Unknown (TAS): ".h2($op,4);
	}elseif(($op&0xFF00)==0x4A00){
		$v=decrm($co,$p,$op,"");
		$si=decsi($op);
		$line=sprintf("TST%s %s",$si,$v);
	}elseif(($op&0xFFC0)==0x4C00){
		// MULU,MULS
		$op2=getint2mac($co,$p);
		$v=decrm($co,$p,$op,"imm4");
		$dh = $op2 & 7;
		$dl = ($op2 >> 12) & 7;
		if ($op2 & 0x0400) {
			// 64-bit result
			$dest = "D".$dh."-D".$dl;
		} else {
			// 32-bit result
			$dest = "D".$dl;
		}
		$signed = (($op2 & 0x0800) ? "S" : "U");
		$line=sprintf("MUL%s %s,%s",$signed,$v,$dest);
	}elseif(($op&0xFFC0)==0x4C40){
		// DIVU,DIVS
		$v=decrm($co,$p,$op,"");
		$op2=getint2mac($co,$p);
		$dr = $op2 & 7;
		$dq = ($op2 >> 12) & 7;
		if ($op2 & 0x0400) {
			// 64-bit dividend
			$dest = "D".$dr.":D".$dq;
		} else {
			// 32-bit dividend
			$dest = "D".$dq;
		}
		$signed = (($op2 & 0x0800) ? "S" : "U");
		$line=sprintf("DIV%s %s,%s",$signed,$v,$dest);
	}elseif(($op&0xFFC0)==0x4CC0){
		$rs=getint2mac($co,$p); $v=decrm($co,$p,$op,"");
		$line=sprintf("MOVEM %s,%s",$v,regs($rs,false));
	}elseif(($op&0xFFF8)==0x4E50){
		$v=getint2mac($co,$p);
		$line=sprintf("LINK A%d,0x%04X",$op&7,$v);
	}elseif(($op&0xFFF8)==0x4E58){
		$line=sprintf("UNLK A%d",$op&7);
	}elseif($op==0x4E74){
		$v=getint2mac($co,$p);
		$line=sprintf("RTD #0x%04X",$v);
		$err=true;
	}elseif($op==0x4E75){
		$line="RTS"; $err=true;
	}elseif(($op&0xFFC0)==0x4E80){
		$aa=$p;
		$v=decrm($co,$p,$op,"imm2");
		$line=sprintf("JSR %s",$v);
		/*
		if(strlen($v)==11 and substr($v,0,3)=="(D_" and substr($v,7,4)==",PC)"){
			$v=hexdec(substr($v,3,4)); if($v>>15) $v-=1<<16;
			$v+=$aa; $line.=" ; = 0x".h2($v,4);
			$threads[]=array($sg,$v);
			$ref = &$labels[$sg][$v];
			$new = "Subroutine entry";
			if (is_null($ref) or array_search($new, $ref) === false) {
				$ref[] = $new;
			}
		}elseif(strlen($v)==11 and substr($v,0,3)=="(D_" and substr($v,7,4)==",A5)"){
			$v=hexdec(substr($v,3,4));
			if ($v >= $A5_offset_of_jump_table and $v-$A5_offset_of_jump_table < $length_of_jump_table) {
				$v=($v-$A5_offset_of_jump_table)>>3;
				$line.=" ; = Entry 0x".h2($v,2);
			}
		}
		*/
		checkrefs($v, true, true);
		$v = null;
	}elseif(($op&0xFFC0)==0x4EC0){
		$aa=$p;
		$v=decrm($co,$p,$op,"imm2");
		$line=sprintf("JMP %s",$v);
		$err=true;
		/*
		if(strlen($v)==11 and substr($v,0,3)=="(D_" and substr($v,7,4)==",PC)"){
			$v=hexdec(substr($v,3,4)); if($v>>15) $v-=1<<16;
			$v+=$aa; $line.=" ; = 0x".h2($v,4);
			$threads[]=array($sg,$v);
		}
		*/
		checkrefs($v, true);
		$v = null;
	}elseif(($op&0xF000)==0x6000){
		$con=$op>>8&15;
		if($con==0) $cond="RA"; elseif($con==1) $cond="SR";
			else $cond=$cons[$con];
		$v=$op&0xFF; if($v>>7) $v-=1<<8;
		$long=$v==0;
		$aa=$p;
		if($v==0){ $v=getint2mac($co,$p); if($v>>15) $v-=1<<16; }
		$si="";
		if($con==1 and !$long) $si=".S";
			elseif($con!=1 and $long) $si=".L";
		$v+=$aa;
		$line=sprintf("B%s%s B_%04X",$cond,$si,$v);
		$threads[]=array($sg,$v);
		if($con==0) $err=true;
	}elseif(($op&0xF0F8)==0x50C8){
		$con=$op>>8&15;
		$aa=$p;
		$r=$op&7; $v=getint2mac($co,$p); if($v>>15) $v-=1<<16;
		$v+=$aa;
		$line=sprintf("DB%s D%d,B_%04X",$cons[$con],$r,$v);
		$threads[]=array($sg,$v);
	}elseif(($op&0xF0C0)==0x50C0){
		$con=$op>>8&15;
		$v=decrm($co,$p,$op,"imm2");
		$line=sprintf("S%s %s",$cons[$con],$v);
	}elseif(($op&0xF100)==0x5000){
		$v=decrm($co,$p,$op,""); $im=decimm($op);
		$si=decsi($op);
		$line=sprintf("ADDQ%s #%d,%s",$si,$im,$v);
	}elseif(($op&0xF100)==0x5100){
		$v=decrm($co,$p,$op,""); $im=decimm($op);
		$si=decsi($op);
		$line=sprintf("SUBQ%s #%d,%s",$si,$im,$v);
	}elseif(($op&0xF000)==0x7000){
		$v=$op&255; $r=$op>>9&7;
		$line=sprintf("MOVEQ #0x%02X,D%d",$v,$r);
	}elseif(($op&0xF1C0)==0x80C0){
		$r=$op>>9&7;
		$v=decrm($co,$p,$op,/*"imm4"*/"imm2"); // bug in dasm68?
		$line=sprintf("DIVU %s,D%d",$v,$r);
	}elseif(($op&0xF1C0)==0x81C0){
		$r=$op>>9&7;
		$v=decrm($co,$p,$op,/*"imm4"*/"imm2"); // bug in dasm68?
		$line=sprintf("DIVS %s,D%d",$v,$r);
	}elseif(($op&0xF100)==0x8000){
		$si=decsi($op); $r=$op>>9&7;
		$v=decrm($co,$p,$op,$si==""?"imm4":"imm2");
		$line=sprintf("OR%s %s,D%d",$si,$v,$r);
	}elseif(($op&0xF100)==0x8100){
		$si=decsi($op); $r=$op>>9&7;
		$v=decrm($co,$p,$op,"");
		$line=sprintf("OR%s D%d,%s",$si,$r,$v);
	}elseif(($op&0xF1C0)==0x90C0){
		$v=decrm($co,$p,$op,"imm4"); $r=$op>>9&7;
		$line=sprintf("SUBA.W %s,A%d",$v,$r);
	}elseif(($op&0xF1C0)==0x91C0){
		$v=decrm($co,$p,$op,"imm4"); $r=$op>>9&7;
		$line=sprintf("SUBA %s,A%d",$v,$r);
	}elseif(($op&0xF138)==0x9100){
		$si=decsi($op); $r1=$op>>9&7; $r2=$op&7;
		$line=sprintf("SUBX%s D%d,D%d",$si,$r2,$r1);
	}elseif(($op&0xF138)==0x9108){
		$err=true;
		$line="Unknown (SUBX.W): ".h2($op,4);
	}elseif(($op&0xF100)==0x9000){
		$si=decsi($op); $r=$op>>9&7;
		$v=decrm($co,$p,$op,$si==""?"imm4":"imm2");
		$line=sprintf("SUB%s %s,D%d",$si,$v,$r);
	}elseif(($op&0xF100)==0x9100){
		$si=decsi($op); $r=$op>>9&7;
		$v=decrm($co,$p,$op,"");
		$line=sprintf("SUB%s D%d,%s",$si,$r,$v);
	}elseif(($op&0xF000)==0xA000){
		$rts=false;
		if ($op & 0x0800) {
			// toolbox traps
			if ($op & 0x0400) $rts=true;
			if(isset($toolbox_traps[$op & 0x3FF])) $line = $toolbox_traps[$op & 0x3FF];
			else $line = sprintf("(unknown toolbox trap 0x%03X)", $op & 0x3FF);
			if($rts) $line .= " + RTS";
			$err = $rts;
		} else {
			// OS traps
			if(isset($os_traps[$op & 0xFF])) $line = $os_traps[$op & 0xFF];
			else $line = sprintf("(unknown OS trap 0x%02X)", $op & 0xFF);
			if ($op & 0x0400) $line .= " + CLEAR"; // initialize block to zero
			if ($op & 0x0200) $line .= " + SYS"; // use the system heap
			if ($op & 0x0100) $line .= " + NO A0"; // no A0
		}
	}elseif(($op&0xF1C0)==0xB0C0){
		$r=$op>>9&7;
		$v=decrm($co,$p,$op,"imm2");
		$line=sprintf("CMPA.W %s,A%d",$v,$r);
	}elseif(($op&0xF1C0)==0xB1C0){
		$r=$op>>9&7;
		$v=decrm($co,$p,$op,"imm4");
		$line=sprintf("CMPA %s,A%d",$v,$r);
	}elseif(($op&0xF100)==0xB000){
		$si=decsi($op); $r=$op>>9&7;
		$v=decrm($co,$p,$op,$si==""?"imm4":"imm2");
		$line=sprintf("CMP%s %s,D%d",$si,$v,$r);
	}elseif(($op&0xF100)==0xB100){
		$si=decsi($op); $ra=$op&7; $rb=$op>>9&7;
		$line=sprintf("CMPM%s (A%d)+,(A%d)+",$si,$ra,$rb);
	}elseif(($op&0xF100)==0xB100){
		$si=decsi($op); $r=$op>>9&7;
		$v=decrm($co,$p,$op,"");
		$line=sprintf("EOR%s D%d,%s",$si,$r,$v);
	}elseif(($op&0xF1C0)==0xC1C0){
		$r=$op>>9&7;
		$v=decrm($co,$p,$op,/*"imm4"*/"imm2"); // bug in dasm68?
		$line=sprintf("MULS %s,D%d",$v,$r);
	}elseif(($op&0xF1C0)==0xC0C0){
		$r=$op>>9&7;
		$v=decrm($co,$p,$op,/*"imm4"*/"imm2"); // bug in dasm68?
		$line=sprintf("MULU %s,D%d",$v,$r);
	}elseif(($op&0xF100)==0xC000){
		$si=decsi($op); $r=$op>>9&7;
		$v=decrm($co,$p,$op,$si==""?"imm4":"imm2");
		$line=sprintf("AND%s %s,D%d",$si,$v,$r);
	}elseif(($op&0xF100)==0xC100){
		$si=decsi($op); $r=$op>>9&7;
		$v=decrm($co,$p,$op,"");
		$line=sprintf("AND%s D%d,%s",$si,$r,$v);
	}elseif(($op&0xF1C0)==0xD0C0){
		$v=decrm($co,$p,$op,"imm2"); $r=$op>>9&7;
		$line=sprintf("ADDA.W %s,A%d",$v,$r);
	}elseif(($op&0xF1C0)==0xD1C0){
		$v=decrm($co,$p,$op,"imm4"); $r=$op>>9&7;
		$line=sprintf("ADDA %s,A%d",$v,$r);
	}elseif(($op&0xF100)==0xD000){
		$si=decsi($op); $r=$op>>9&7;
		$v=decrm($co,$p,$op,$si==""?"imm4":"imm2");
		$line=sprintf("ADD%s %s,D%d",$si,$v,$r);
	}elseif(($op&0xF138)==0xD100){
		$si=decsi($op); $r1=$op>>9&7; $r2=$op&7;
		$line=sprintf("ADDX%s D%d,D%d",$si,$r2,$r1);
	}elseif(($op&0xF138)==0xD108){
		$err=true;
		$line="Unknown (ADDX.W): ".h2($op,4);
	}elseif(($op&0xF100)==0xD100){
		$si=decsi($op); $r=$op>>9&7;
		$v=decrm($co,$p,$op,"");
		$line=sprintf("ADD%s D%d,%s",$si,$r,$v);
	}elseif(($op&0xF8C0)==0xE8C0){
		$o=$op>>8&7; $bi=getint2mac($co,$p);
		$va=$bi>>6&63; $vb=$bi&63;
		$v=decrm($co,$p,$op,"");
		if($va&32) $va="D".($va&7); else $va="#".$va;
		if($vb&32) $vb="D".($vb&7); else $vb="#".($vb?$vb:32);
		$bfs=array("BFTST %s{%s:%s}","BFEXTU %s{%s:%s},D6","BFCHG %s{%s:%s}","BFEXTS %s{%s:%s},D6",
			"BFCLR %s{%s:%s}","BFFFO %s{%s:%s},D6","BFSET %s{%s:%s}","BFINS D6,%s{%s:%s}");
		$line=sprintf($bfs[$o],$v,$va,$vb);
	}elseif(($op&0xF0C0)==0xE0C0){
		$err=true;
		$line="Unknown (shift): ".h2($op,4);
	}elseif(($op&0xF000)==0xE000){
		$sh=$op>>3&3; $dr=$op>>8&1;
		if($op>>5&1){
			$r="D".($op>>9&7);
		}else{
			$r="#".decimm($op);
		}
		//$v=decrm($co,$p,$op,"");
		$v="D".($op&7);
		$line=sprintf("%s%s %s,%s",$shs[$sh],$drs[$dr],$r,$v);
	}else{
		$err=true;
		$line="Unknown opcode: ".h2($op,4);
	}
	if($err) $line.="\r\n";

	checkrefs($v );
	checkrefs($va);
	checkrefs($vb);
	@list($opcode,$operands) = explode(" ",$line,2);
	$line = sprintf("%-6s %s", $opcode, $operands);

	$line=sprintf("%-24s %s",str2hex(substr($co,$sa,$p-$sa)),$line);
	$next[$sg][$sa]=$p;
//	if(!isset($dec[$sg][$p])) $dec[$sg][$p]="";
	if($err){
		$dec[$sg][$sa]=$line;
		if(isset($dec[$sg][$sa])){
			if(count($threads)==0) break;
			list($sg,$p)=array_shift($threads);
			$co=substr($f["CODE"][$sg],4);
			continue;
		}
	}
	$dec[$sg][$sa]=$line;
}

ksort($dec);
foreach($dec as $sg=>$sgs){
	ksort($sgs);
	$co=substr($f["CODE"][$sg],4);
	// show name of CODE resource
	$name = @$f["_names"]["CODE"][$sg];
	printf(" ; CODE 0x%04X", $sg);
	if ($name) printf(": %s\r\n", $name);
	printf("\r\n");
	$en=0;
	foreach($sgs as $of=>$v){
	//	if($k==$start) print "START\r\n";
		if($en<$of) print h2($sg,2).":".h2($en,4).": [unexplored] ".urlencode(substr($co,$en,$of-$en))."\r\n";
		elseif($en>$of) print h2($sg,2).":".h2($en,4).": "."NEGATIVE JUMP!"."\r\n";
		if(isset($comments[$sg][$of])){
			print " ; ".implode(", ", $comments[$sg][$of])."\r\n";
		}
		if(isset($labels[$sg][$of])){
			print " ; ".implode(", ", $labels[$sg][$of])."\r\n";
		}
		print h2($sg,2).":".h2($of,4).": ".$v."\r\n";
		$en=$next[$sg][$of];
	}
	$of=strlen($co);
	if($en!=$of) print h2($sg,2).":".h2($en,4).": [unexplored] ".urlencode(substr($co,$en,$of-$en))."\r\n";
	print "\r\n";
}


